SystemOrganization addCategory: #'Kiwi-UI'!

MorphTreeNodeModel subclass: #KiwiResultItemTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiResultItemTreeNodeModel commentStamp: 'NahuelGarbezza 1/8/2012 00:54' prior: 0!
I am a tree node model that maps to an element of the Gherkin AST.!

KiwiResultItemTreeNodeModel subclass: #KiwiFeatureTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiFeatureTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 4/23/2012 08:44'!
asString

	^self astNode title! !

!KiwiFeatureTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:36'!
childNodeClassFromItem: anItem

	^(anItem astNode isKindOf: KiwiScenarioASTNode)
		ifTrue: [ KiwiScenarioTreeNodeModel ]
		ifFalse: [ KiwiScenarioOutlineTreeNodeModel ]! !

!KiwiFeatureTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:44'!
childrenItems

	^self item scenarioResults! !

!KiwiResultItemTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:44'!
astNode

	^self item astNode! !

!KiwiResultItemTreeNodeModel methodsFor: 'content' stamp: 'NahuelGarbezza 4/23/2012 08:36'!
content

	| formatter |
	formatter := KiwiFormatterVisitor new.
	self item astNode accept: formatter.
	^formatter stream contents! !

KiwiResultItemTreeNodeModel subclass: #KiwiScenarioOutlineTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiScenarioOutlineTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 1/7/2012 20:13'!
asString

	^self item title
		ifEmpty: [ ^'<Unnamed scenario outline>' ]
		ifNotEmpty: [ self item title ]! !

!KiwiScenarioOutlineTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/7/2012 20:36'!
childNodeClassFromItem: anItem

	^KiwiScenarioTreeNodeModel! !

!KiwiScenarioOutlineTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/7/2012 20:14'!
childrenItems

	^self item allScenarios! !

KiwiResultItemTreeNodeModel subclass: #KiwiScenarioTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiScenarioTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 4/23/2012 08:44'!
asString

	^self astNode title
		ifEmpty: [ ^'<Unnamed scenario>' ]
		ifNotEmpty: [ self astNode title ]! !

!KiwiScenarioTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 1/7/2012 20:37'!
childNodeClassFromItem: anItem

	^KiwiStepTreeNodeModel! !

!KiwiScenarioTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:44'!
childrenItems

	^self item stepResults! !

KiwiResultItemTreeNodeModel subclass: #KiwiStepErrorTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiStepErrorTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 12/30/2011 12:24'!
asString

	^'Error: ' , self item messageText! !

!KiwiStepErrorTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/30/2011 09:55'!
childrenItems

	^{}! !

!KiwiStepErrorTreeNodeModel methodsFor: 'content' stamp: 'NahuelGarbezza 4/23/2012 08:45'!
content

	^self item description! !

KiwiResultItemTreeNodeModel subclass: #KiwiStepMatchingMethodTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiStepMatchingMethodTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 12/30/2011 12:24'!
asString

	^'Match: ' , (self item printString copyFrom: 2 to: (self item printString indexOf: $") - 2)! !

!KiwiStepMatchingMethodTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/30/2011 09:55'!
childrenItems

	^{}! !

!KiwiStepMatchingMethodTreeNodeModel methodsFor: 'content' stamp: 'NahuelGarbezza 12/30/2011 10:14'!
content

	^self item asString! !

KiwiResultItemTreeNodeModel subclass: #KiwiStepStateTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiStepStateTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 4/30/2012 23:46'!
asString

	^'Status: ' , self item asString capitalized! !

!KiwiStepStateTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/30/2011 10:02'!
childrenItems

	^{}! !

!KiwiStepStateTreeNodeModel methodsFor: 'content' stamp: 'NahuelGarbezza 12/30/2011 10:28'!
content

	^''! !

KiwiResultItemTreeNodeModel subclass: #KiwiStepTreeNodeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiStepTreeNodeModel methodsFor: 'converting' stamp: 'NahuelGarbezza 4/23/2012 08:46'!
asString

	^self astNode kind , ' ' , self astNode body! !

!KiwiStepTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:41'!
childNodeClassFromItem: anItem

	anItem isCompiledMethod ifTrue: [ ^KiwiStepMatchingMethodTreeNodeModel ].
	(anItem isKindOf: Error) ifTrue: [ ^KiwiStepErrorTreeNodeModel ].
	(anItem isKindOf: Symbol) ifTrue: [ ^KiwiStepStateTreeNodeModel ].
! !

!KiwiStepTreeNodeModel methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:40'!
childrenItems

	| result |
	result := OrderedCollection new.
	result add: self item status.
	self item hasMatchingDefinition ifTrue: [ result add: self item matchingDefinition ].
	self item isFailed ifTrue: [ result add: self item failure ].
	^result asArray! !

Object subclass: #KiwiAddFeatureDialog
	instanceVariableNames: 'option classSelected classSelectedLabel methodSelectedLabel featureFilePath featureFilePathField parentWindow methodSelected featuresToAdd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiAddFeatureDialog commentStamp: 'NahuelGarbezza 1/8/2012 00:53' prior: 0!
I am a Dialog for adding new features to the main window.!

!KiwiAddFeatureDialog class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 1/10/2012 16:26'!
openOn: window

	^self new openOn: window! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'NahuelGarbezza 9/23/2011 12:14'!
defaultOption

	^#newFeature! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 23:13'!
featureContent

	^self featureToAdd collect: [:each| each featureContent]! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:53'!
featureFilePath

	^(self featuresToAdd isNil | self featuresToAdd isEmpty | self isFeatureInFileSystem not)
		ifTrue: [ '' ]
		ifFalse: [ self featureToAdd path ]! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:54'!
featureFilePath: aPath

	self featureToAdd path: aPath.! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'NahuelGarbezza 10/9/2011 06:46'!
featureName

	^self featureToAdd featureName! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:52'!
featureToAdd

	^self featuresToAdd first! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:52'!
featureToAdd: aFeature
	featuresToAdd := OrderedCollection with: aFeature! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:51'!
featuresToAdd

	^featuresToAdd! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'bastiankruck 6/24/2012 21:52'!
featuresToAdd: anOrderedCollection
	featuresToAdd := anOrderedCollection! !

!KiwiAddFeatureDialog methodsFor: 'testing' stamp: 'NahuelGarbezza 10/9/2011 08:55'!
isCancelled

	^parentWindow cancelled! !

!KiwiAddFeatureDialog methodsFor: 'testing' stamp: 'NahuelGarbezza 9/23/2011 11:20'!
isFeatureInFileSystem

	^self option == #featureInFileSystem! !

!KiwiAddFeatureDialog methodsFor: 'testing' stamp: 'NahuelGarbezza 9/23/2011 11:20'!
isFeatureInSmalltalkImage

	^self option == #featureInSmalltalkImage.! !

!KiwiAddFeatureDialog methodsFor: 'testing' stamp: 'NahuelGarbezza 9/23/2011 11:21'!
isNewFeature

	^self option == #newFeature.! !

!KiwiAddFeatureDialog methodsFor: 'opening' stamp: 'bastiankruck 6/24/2012 22:47'!
openOn: window

	|dialog|
	self setNewFeature.
	dialog := (UITheme builder newPluggableDialogWindow: 'Please select the source of the feature')
		useDefaultOKCancelButton.
	dialog contentMorph: (dialog newColumn: {
		dialog
			newRadioButtonFor: self
			getSelected: #isNewFeature
			setSelected: #setNewFeature
			label: 'New'
			help: ''.
		dialog
			newRadioButtonFor: self
			getSelected: #isFeatureInSmalltalkImage
			setSelected: #setFeatureInSmalltalkImage
			label: 'In the Smalltalk Image'
			help: ''.
		dialog newRow: {
			dialog newButtonFor: self action: #searchFeaturesByCategory getEnabled: #isFeatureInSmalltalkImage label: 'By Category' help: ''.
			dialog newButtonFor: self action: #searchClassOfFeature getEnabled: #isFeatureInSmalltalkImage label: 'By a method' help: ''.
			classSelectedLabel := dialog newLabel: 'No class selected'.
			dialog newLabel: '>>'.
			methodSelectedLabel := dialog newLabel: 'No method selected'.
		}.
		dialog 
			newRadioButtonFor: self
			getSelected: #isFeatureInFileSystem
			setSelected: #setFeatureInFileSystem
			label: 'In the filesystem'
			help: ''.
		dialog newRow: {
			dialog newLabelFor: self label: 'File:' getEnabled: #isFeatureInFileSystem.
			featureFilePathField := dialog
				newTextEntryFor: self
				getText: #featureFilePath
				setText: #featureFilePath:
				getEnabled: #isFeatureInFileSystem
				help: ''.
			dialog newButtonFor: self action: #searchFeatureFilePath getEnabled: #isFeatureInFileSystem label: 'Search file...' help: ''.
		}.
	}); model: nil.
	parentWindow := dialog.
	window openModal: dialog.! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'NahuelGarbezza 9/23/2011 11:22'!
option

	^option! !

!KiwiAddFeatureDialog methodsFor: 'accessing' stamp: 'NahuelGarbezza 9/23/2011 11:51'!
option: anObject

	option := anObject.
	self
		changed: #isNewFeature;
		changed: #isFeatureInSmalltalkImage;
		changed: #isFeatureInFileSystem.! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 22:47'!
searchClassOfFeature

	classSelected := (OBCompletionDialog	openOn: (
		OBCompletionRequest new
			collection: Smalltalk allClasses caseSensitive: false;
			prompt: 'Select a class'
		)
	) answer.
	
	classSelected ifNotNil: [
		classSelectedLabel contents: classSelected asString.
		self featureToAdd featureClass: classSelected name.
		self searchMethodOfFeature.
	].! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'NahuelGarbezza 11/2/2011 12:36'!
searchFeatureFilePath
	
	| path |
	path := UITheme new
		chooseFullFileNameIn: parentWindow
		title: 'Please select the .feature file'
		patterns: nil
		path: nil
		preview: nil.
	path ifNotNil: [ featureFilePathField setText: path. self featureFilePath: path ].! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 23:00'!
searchFeaturesByCategory
	| classesSelected categoryName choices |
	choices := self class environment organization categories.
	categoryName :=  (OBCompletionDialog openOn: (
		OBCompletionRequest new
			collection: choices caseSensitive: false;
			prompt: 'Select a category containing your <feature>s'
		)
	) answer.
	
	classesSelected :=(self class environment organization classesInCategory: categoryName)
		gather:	[ :klass | Pragma allNamed: #feature in: klass ].
	
	self featuresToAdd removeAll.
	classesSelected do: [ :pragma |
		
		classSelectedLabel contents: categoryName.
		self featuresToAdd add: (KiwiFeatureFromMethod 
			class: pragma methodClass name 
			method: pragma selector).
		parentWindow ok.
	].! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 22:52'!
searchMethodOfFeature

	|choices|
	choices := (classSelected allMethods select: [ :m | m methodClass = classSelected ]) collect: #selector.
	
	methodSelected := (OBCompletionDialog openOn: (
		OBCompletionRequest new
			collection: choices caseSensitive: false;
			prompt: 'Select a method containing the feature'
		)
	) answer.
	
	methodSelected ifNotNil: [
		methodSelectedLabel contents: methodSelected asString.
		self featureToAdd featureMethod: methodSelected.
		parentWindow ok.
	].! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 21:40'!
setFeatureInFileSystem

	self isFeatureInFileSystem ifFalse: [ self featureToAdd: (KiwiFeatureFromFile path: featureFilePath) ].
	self option: #featureInFileSystem.! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 21:42'!
setFeatureInSmalltalkImage

	self isFeatureInSmalltalkImage ifFalse:
		[ self featureToAdd: (KiwiFeatureFromMethod class: classSelected name method: methodSelected) ].
	self option: #featureInSmalltalkImage.! !

!KiwiAddFeatureDialog methodsFor: 'private' stamp: 'bastiankruck 6/24/2012 21:42'!
setNewFeature

	self featureToAdd: (KiwiNewFeature content: '').
	self option: #newFeature.! !

Object subclass: #KiwiResultsWindow
	instanceVariableNames: 'builder treeView textEditor output selectedResult buttonsPanel browseButton result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiResultsWindow commentStamp: 'NahuelGarbezza 1/8/2012 00:53' prior: 0!
I am the window responsible for showing the results of a Kiwi execution.!

!KiwiResultsWindow class methodsFor: 'opening' stamp: 'NahuelGarbezza 1/10/2012 16:24'!
openOn: aRunner

	^self new openOn: aRunner.! !

!KiwiResultsWindow methodsFor: 'events' stamp: 'NahuelGarbezza 2/17/2012 10:28'!
browseStepDefinition

	|selected|
	selected := treeView selectedMorph complexContents.
	Smalltalk tools browser
		fullOnClass: selected item methodClass
		selector: selected item selector! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 4/23/2012 08:04'!
counterLabel: aSymbol

	| total out |
	total := self result perform: (#total , aSymbol capitalized , #s) asSymbol.
	out := WriteStream on: ''.
	out
		nextPutAll: total printString;
		nextPut: Character space;
		nextPutAll: aSymbol asString.
	total = 1 ifFalse: [ out nextPut: $s ].
	total > 0 ifFalse: [ ^out contents ].
	out nextPut: Character space;	nextPut: $(; nextPut: Character space.
	#(passed failed pending undefined skipped)
		do: [ :status | self writeStatusLabel: aSymbol status: status on: out ].
	out nextPut: $).
	
	^out contents! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 2/17/2012 10:30'!
createBottomButtons

	^buttonsPanel := builder newRow: {
		"builder newButtonFor: self action: #runAgain label: 'Run again' help: 'Run this features again and show the results'."
	}! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 4/23/2012 08:05'!
createMainWindow

	^builder newColumn: {
		self createResultsCounterFor: #feature.
		self createResultsCounterFor: #scenario.
		self createResultsCounterFor: #step.
		(builder newRow: {
			self createTreeView.
			self createTextView.
		}) vResizing: #spaceFill; yourself.
		self createBottomButtons.
	}! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 4/23/2012 08:06'!
createResultsCounterFor: aSymbol

	^(builder newRow: {
		(builder
			newLabelFor: self
			label: (self perform: #counterLabel: with: aSymbol)
			getEnabled: nil)
	}) fillStyle: (SolidFillStyle color: (self perform: (aSymbol, #Color) asSymbol));
	layoutInset: 5! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 1/13/2012 18:51'!
createTextView

	^textEditor := builder
		newTextEditorFor: self
		getText: #output
		setText: #output:! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 4/22/2012 19:46'!
createTreeView

	^treeView := builder
		newTreeFor: self
		list: #resultsModels
		selected: #selectedResult
		changeSelected: #selectedResultChanged:! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:06'!
featureColor

	self result failedFeatures > 0 ifTrue: [ ^Color red ].
	self result pendingFeatures > 0 ifTrue: [ ^Color yellow ].
	self result undefinedFeatures > 0 ifTrue: [ ^Color gray ].
	self result passedFeatures > 0 ifTrue: [ ^Color green ].
	^Color transparent! !

!KiwiResultsWindow methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 12/23/2011 20:16'!
initialize

	output := ''.! !

!KiwiResultsWindow methodsFor: 'opening' stamp: 'NahuelGarbezza 4/30/2012 23:47'!
openOn: aResult

	result := aResult.
	builder := UITheme builder.
	(self createMainWindow openInWindowLabeled: 'Results') extent: 900@600! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/23/2011 20:15'!
output

	^output! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/23/2011 11:51'!
output: anObject
	output := anObject! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/22/2012 18:26'!
result

	^result! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:43'!
resultsModels

	^self result featureResults
		collect: [ :feature | KiwiFeatureTreeNodeModel with: feature ]! !

!KiwiResultsWindow methodsFor: 'actions' stamp: 'NahuelGarbezza 2/4/2012 18:51'!
runAgain

	self runner run.
	self updateUI.! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:06'!
scenarioColor

	self result failedScenarios > 0 ifTrue: [ ^Color red ].
	self result pendingScenarios > 0 ifTrue: [ ^Color yellow ].
	self result undefinedScenarios > 0 ifTrue: [ ^Color gray ].
	self result passedScenarios > 0 ifTrue: [ ^Color green ].
	^Color transparent! !

!KiwiResultsWindow methodsFor: 'events' stamp: 'NahuelGarbezza 12/23/2011 18:02'!
selectedResult

	^selectedResult! !

!KiwiResultsWindow methodsFor: 'events' stamp: 'NahuelGarbezza 2/17/2012 10:29'!
selectedResultChanged: item

	item ifNotNil: [
		treeView selection: item.
		selectedResult := item content.
		(item isKindOf: KiwiStepMatchingMethodTreeNodeModel)
			ifTrue: [
				(buttonsPanel submorphs includes: browseButton) ifFalse: [
					browseButton := UITheme builder
						newButtonFor: self
						action: #browseStepDefinition
						label: 'Browse step definition' help: ''.
					buttonsPanel addMorph: browseButton.
					textEditor setText: ''.
				].
			]
			ifFalse: [
				textEditor setText: selectedResult asText.
				browseButton ifNotNil: [
					buttonsPanel removeMorph: browseButton.
					browseButton := nil.
				]
			].
	]! !

!KiwiResultsWindow methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/23/2012 08:06'!
stepColor

	self result failedSteps > 0 ifTrue: [ ^Color red ].
	self result pendingSteps > 0 ifTrue: [ ^Color yellow ].
	self result undefinedSteps > 0 ifTrue: [ ^Color gray ].
	self result passedSteps > 0 ifTrue: [ ^Color green ].
	self result skippedSteps > 0 ifTrue: [ ^Color cyan ].
	^Color transparent! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 2/4/2012 18:53'!
updateUI

	treeView update: #results! !

!KiwiResultsWindow methodsFor: 'private' stamp: 'NahuelGarbezza 4/23/2012 07:59'!
writeStatusLabel: aSymbol status: status on: aStream

	|statusResult|
	statusResult := self result perform: (status , aSymbol capitalized , #s) asSymbol.
	statusResult > 0 ifTrue: [
		aStream
			nextPutAll: statusResult printString;
			nextPut: Character space;
			nextPutAll: status asString;
			nextPut: Character space.
	]! !

Object subclass: #KiwiUI
	instanceVariableNames: 'builder mainWindow featuresTabGroup stepClassesList stepDefinitionSelectionIndex runner runAllFeaturesButton runSelectedFeatureButton removeStepDefButton saveToFileButton saveToMethodButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kiwi-UI'!

!KiwiUI commentStamp: 'NahuelGarbezza 1/8/2012 00:53' prior: 0!
I am the main window of the Kiwi user interface.!

!KiwiUI class methodsFor: 'help' stamp: 'NahuelGarbezza 10/27/2011 20:56'!
helpMessageTags

	^'Tags allow you to filter features or scenarios
in the execution. Tags must be placed before the definition of
a feature or scenario. Example:

@in-progress
Feature: x

	Scenario: x1
		Given...
	
	@release1.2 @slow
	Scenario: x2
		Given...
	
Here, the scenarios x1 and x2 are tagged with @in-progress tag, and x2 is also tagged
with @release1.2 and @slow.

Then, you can specify the tags to run combining as you like, based on the following rules:
	* naming a tag (@tag1) will run scenarios tagged with this tag.
	* putting a ~ character before naming the tag (~@tag1) will NOT run scenarios tagged with this tag.
	* the | (pipe) character combines two tag expressions via OR.
	* the & (ampersand) character combines two tag expressions via AND.
	* you can put tag expressions between parenthesis.
	
Examples:
	@tag1 | @tag2 					Scenarios tagged with @tag1 OR @tag2
	~@tag1 | @tag2 				Scenarios not tagged with @tag1 OR tagged with @tag2
	(@tag1 | @tag2) & ~@tag3 	Scenarios with @tag1 OR @tag2, but NOT with @tag3
'! !

!KiwiUI class methodsFor: 'menu item' stamp: 'NahuelGarbezza 10/27/2011 20:34'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'Kiwi BDD')
		order: 3;
		label: 'Kiwi BDD';
		icon: ThemeIcons kiwiIcon;
		action: [ self open ]! !

!KiwiUI class methodsFor: 'interface opening' stamp: 'NahuelGarbezza 1/10/2012 16:24'!
open

	^self new openAndInitialize! !

!KiwiUI class methodsFor: 'interface opening' stamp: 'NahuelGarbezza 1/10/2012 16:24'!
openOn: aProfileOrRunner

	^self new openAndInitialize: aProfileOrRunner runner! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 2/6/2012 09:28'!
addStepDefinitionClass
	
	| className |
	className := (OBCompletionDialog openOn: 
		(OBCompletionRequest new
			collection: Smalltalk keys asSortedCollection caseSensitive: false;
			prompt: 'Select a class';
			yourself)) answer.
	className ifNotNil: [ 
		runner addStepDefinitionsClass: className.
		stepClassesList updateList.
		removeStepDefButton update: #isThereStepDefClasses.
	]! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/5/2012 11:23'!
createAddFeatureButton

	^builder
		newButtonFor: self
		action: #openAddFeatureWindow
		label: 'Add feature...'
		help: 'Add a feature to the runner''s list of features'! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 10/9/2011 13:23'!
createAddStepDefButton

	^builder
		newButtonFor: self
		action: #addStepDefinitionClass
		label: 'Add class'
		help: 'Add a class with step definitions'! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 12/22/2011 16:18'!
createFeaturesTabGroup

	featuresTabGroup := builder newTabGroup: {}.
	self runner features do: [ :feature | self createTabForFeature: feature ].
	^featuresTabGroup! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 11/2/2011 12:29'!
createMainButtons

	^builder newRow: { 
		runAllFeaturesButton := builder
			newButtonFor: self
			action: #runAllFeatures
			getEnabled: #isThereFeatures
			label: 'Run all features'
			help: 'Runs all the features in this profile'.
		runSelectedFeatureButton := builder
			newButtonFor: self
			action: #runSelectedFeature
			getEnabled: #isThereFeatures
			label: 'Run current feature'
			help: 'Runs the current selected feature'
	}! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:00'!
createMainWindow

	^builder newColumn: {
		builder newRow: {
			self createAddFeatureButton.
			saveToFileButton := self createSaveToFileButton.
			saveToMethodButton := self createSaveToMethodButton.
		}.
		self createFeaturesTabGroup.
		self createStepDefinitionsPanel vResizing: #shrinkWrap.
		self createTagsPanel vResizing: #shrinkWrap.
		self createMainButtons vResizing: #shrinkWrap.
	}! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 09:25'!
createRemoveSelectedStepDefButton
	
	^builder
		newButtonFor: self
		action: #removeSelectedStepDefClass
		getEnabled: #isThereStepDefClasses
		label: 'Remove selected'
		help: 'Remove the selected class from this window'! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:00'!
createSaveToFileButton

	^builder
		newButtonFor: self
		action: #saveFeatureToFile
		getEnabled: #isThereFeatures
		label: 'Save to file...'
		help: 'Save the current feature to a file'! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:13'!
createSaveToMethodButton

	^builder
		newButtonFor: self
		action: #saveFeatureToMethod
		getEnabled: #disabled
		label: 'Save to method...'
		help: 'Save the current feature to a method in a given class'! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 09:28'!
createStepDefinitionsPanel

	^builder newGroupbox: 'Step definitions' forAll: {
		builder newRow: {
			builder newColumn: {
				self createAddStepDefButton.
				removeStepDefButton := self createRemoveSelectedStepDefButton.
			}.
			stepClassesList := builder
				newListFor: self
				list: #stepDefinitionsClasses
				selected: #stepDefinitionClassSelected
				changeSelected: #stepClassSelectionChanged:
				help: 'Cucumber will search for steps definitions in these classes'
		}.
	}.! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:02'!
createTabForFeature: aFeature

	| featureTextEditor featureTabLabel |
	featureTextEditor := builder
			newTextEditorFor: aFeature
			getText: #featureContent
			setText: #featureContent:.
	featureTabLabel :=  builder newRow: {
		builder newLabel: aFeature featureName.
	 	builder
			newCloseControlFor: nil
			action: [
				(builder confirm: 'Remove the feature from this configuration?') ifTrue: [
					featuresTabGroup removePage: featureTextEditor.
					runner removeFeature: featureTextEditor model.
					self updateFeatureButtons.
				]
			] help: 'Removes this feature from the runner'
	}.
	featuresTabGroup addPage: featureTextEditor label: featureTabLabel.
	featuresTabGroup selectedPageIndex: (featuresTabGroup pages indexOf: featureTextEditor).
	featureTextEditor setText: aFeature featureContent.
	self updateFeatureButtons.! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 11/22/2011 20:33'!
createTagsPanel

	^builder newGroupbox: 'Tags' forAll: {
		builder newRow: {
			builder newLabelGroup: {
				'Tag filter:' -> (builder
					newTextEntryFor: self runner
					getText: #tagFilter
					setText: #tagFilter:
					help: 'Tags to include/exclude. Examples: @tag1, ~@tag2, (@tag1 & @tag2)'
				)
			}.
			builder
				newButtonFor: self
				action: #openTagsHelp
				label: '?'
				help: 'Shows some tags usage & examples'.
		}.		
	}! !

!KiwiUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 10/12/2011 10:47'!
currentFeature

	^self runner features at: featuresTabGroup selectedPageIndex! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:13'!
disabled

	^false! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/2/2012 16:07'!
handleRun: aBlock

	aBlock
		on: KiwiError
		do: [ :error | |  dialogBuilder dialog |
			dialogBuilder := UITheme builder.
			dialog := (dialogBuilder newPluggableDialogWindow: 'An error in Kiwi has occurred') useDefaultOKButton.
			dialog contentMorph: error messageText asMorph.
			dialog model: nil.
			mainWindow openModal: dialog
		].! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 09:26'!
isThereFeatures

	^self runner features notEmpty! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 09:25'!
isThereStepDefClasses

	^self runner stepDefinitionsClasses notEmpty! !

!KiwiUI methodsFor: 'actions' stamp: 'bastiankruck 6/24/2012 21:56'!
openAddFeatureWindow
	"Opens a window requesting the source of the feature to add"

	| dialog |
	dialog := KiwiAddFeatureDialog openOn: mainWindow.
	dialog isCancelled ifTrue: [ ^self ].
	dialog featuresToAdd do: [:feature|
	[feature featureContent.
	runner addFeature: feature.
	self createTabForFeature: feature ]
		on: KiwiError
		do: [ :e | UITheme new
			alertIn: mainWindow
			text: e messageText
			title: 'Error'
			configure: [ :d |]
		] ].! !

!KiwiUI methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 12/22/2011 16:02'!
openAndInitialize

	^self openAndInitialize: KiwiRunner new! !

!KiwiUI methodsFor: 'initialize-release' stamp: 'NahuelGarbezza 10/27/2011 20:35'!
openAndInitialize: aRunner

	runner := aRunner.
	builder := UITheme builder.
	mainWindow := (self createMainWindow openInWindowLabeled: 'Kiwi BDD') extent: 500@500.! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/22/2012 18:30'!
openResultsWindow: aResult

	^KiwiResultsWindow openOn: aResult! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 11/2/2011 12:34'!
openTagsHelp
	
	UITheme new messageIn: mainWindow text: self class helpMessageTags title: 'About tags'! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 2/6/2012 09:29'!
removeSelectedStepDefClass
	
	runner removeStepDefinitionsClass: stepClassesList selection.
	stepClassesList updateList.
	removeStepDefButton update: #isThereStepDefClasses! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 10:02'!
replaceFeature: oldFeature with: newFeature

	featuresTabGroup selectedPageIndex: 0.
	runner removeFeature: oldFeature.
	featuresTabGroup removePage: (featuresTabGroup pages detect: [ :p | p model == oldFeature ]).
	runner addFeature: newFeature.
	self createTabForFeature: newFeature.! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/22/2012 18:29'!
runAllFeatures

	self handleRun: [ self openResultsWindow: self runner run ]! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/22/2012 18:29'!
runSelectedFeature 
	
	self handleRun: [
		self openResultsWindow: (self runner runFeature: self currentFeature)
	]! !

!KiwiUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 10/9/2011 13:41'!
runner

	^runner! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/29/2012 15:34'!
saveFeatureToFile

	| newFeature path |
	path := UITheme new
		fileSaveIn: mainWindow
		title: 'Select or write the feature file name'
		extensions: nil path: nil.
	path ifNotNil: [
		newFeature := self currentFeature saveToFile: path fullName.
		self currentFeature isNewFeature
			ifTrue: [ self replaceFeature: self currentFeature with: newFeature ]
			ifFalse: [
			(UITheme new
				chooseIn: mainWindow
				title: 'Replace the old feature with the new one in the runner?'
				labels: #('Yes' 'No')
				values: #(true false)
				lines: nil)
				ifTrue: [ self replaceFeature: self currentFeature with: newFeature ]
		]
	]! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 2/6/2012 17:12'!
saveFeatureToMethod

	| newFeature class method category |
	self halt. "TODO"
	class := (OBCompletionDialog openOn: (
		OBCompletionRequest new
			collection: Smalltalk allClasses caseSensitive: false;
			prompt: 'Select a class'
		)
	) answer.
	class ifNil: [ ^self ].
	method := (OBCompletionDialog	openOn: (
		OBCompletionRequest new
			collection: class  caseSensitive: false;
			prompt: 'Select a class'
		)
	) answer.
	method ifNil: [ ^self ].
	category := 'xxx'.
	newFeature := self currentFeature saveToMethod: method class: class category: category.
	self currentFeature isNewFeature ifTrue: [
		self replaceFeature: self currentFeature with: newFeature.
	] ifFalse: [
		"dialog preguntando si se reemplaza, si no es newFeature"
		self replaceFeature: self currentFeature with: newFeature.
	].! !

!KiwiUI methodsFor: 'actions' stamp: 'NahuelGarbezza 10/9/2011 11:40'!
stepClassSelectionChanged: index

	stepDefinitionSelectionIndex := index.
	stepClassesList updateList.! !

!KiwiUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 10/9/2011 11:39'!
stepDefinitionClassSelected

	^stepDefinitionSelectionIndex ifNil: [ 1 ] ifNotNil: [ stepDefinitionSelectionIndex ]! !

!KiwiUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 10/28/2011 10:35'!
stepDefinitionsClasses

	^self runner stepDefinitionsClasses! !

!KiwiUI methodsFor: 'private' stamp: 'NahuelGarbezza 2/6/2012 17:04'!
updateFeatureButtons

	{runSelectedFeatureButton. runAllFeaturesButton.
	saveToFileButton. saveToMethodButton}
		do: [ :each | each update: #isThereFeatures ]! !
